Summary: VIA sound driver (VT3074/VT3068).
Name:    viaudiocombo
Version: 2.3
Release: 1 	 
Vendor: VIA Multimedia Team
Copyright:VIA Tech
Group: System Environment/Base
Source:viaudiocombo-2.3.tar.gz
BuildRoot:%{_builddir}/%{name}-root


%description
 VIA combo audio driver for kernel 2.4.x. 

%define kerver %(uname -r)

%prep

%setup -q

%build
./install.sh

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/etc/init.d
mkdir -p $RPM_BUILD_ROOT/lib/modules/%{kerver}/kernel/drivers/sound
install   viasound  $RPM_BUILD_ROOT/etc/init.d/viasound
install  -m 644 viaudiocombo.o $RPM_BUILD_ROOT/lib/modules/`uname -r`/kernel/drivers/sound/viaudiocombo.o

%post
#!/bin/bash
KERNELVERSION=`uname -r`
SOUNDDRIVERDIR=/lib/modules/$KERNELVERSION/kernel/drivers/sound
MODULESDEPDIR=/lib/modules/$KERNELVERSION
MODULESCONFDIR=/etc
MODULESCONFFILE=$MODULESCONFDIR/modules.conf
OLDMODULESCONFFILE=$MODULESCONFDIR/old.modules.conf
RPMDIR=

echo -e " -------- install start --------"
#VT686A, VT686B, VT8231, VT8233, VT8233A, VT8233C, VT8235 Shell script 

	#backup config.modules
	if [ ! -f $OLDMODULESCONFFILE ] ; then
		cp $MODULESCONFFILE $OLDMODULESCONFFILE
		sed -e '/^alias snd-card-.*/d' -e '/^.*snd-slot-.*/d' -e '/^alias sound-.*/d' -e '/^above snd-.*/d' -e '/^options snd.*/d'  -e '/^.*snd$/d' -e '/^.*soundcore$/d' $MODULESCONFFILE > modules.conf.tmp
		echo "alias sound-slot-0 viaudiocombo" >> modules.conf.tmp
		echo -e " backup modules.conf to old.modules.conf"
                
	else
		echo -e " old.modules.conf already exist"
	fi


	if [ -f modules.conf.tmp ] ; then
	     	cp modules.conf.tmp $MODULESCONFFILE 
		rm modules.conf.tmp
	fi


	#remove alsa sound start  and kill shell srcipt from /etc/init.d/rc($runlevel).d
	#create S??viasound K??viasound link to /etc/init.d/viasound
        if  grep -q "Mandrake" /etc/issue  ; then
        	OSProduct="Mandrake"
	elif  grep -q "SuSE" /etc/issue ; then
        	OSProduct="SuSE"
	elif  grep -q "Red Flag" /etc/issue ; then
        	OSProduct="Red Flag"
	fi

	if [ ! -x /etc/init.d/sound ];then
       		LEVEL="   2 3  5  "
        	for runlevel in $LEVEL ; do
	        	if [ -L /etc/rc.d/rc${runlevel}.d/K??alsa* ]; then
                  	     rm /etc/rc.d/rc${runlevel}.d/K??alsa*
	        	fi
                	if [ ! -L /etc/rc.d/rc{runlevel}.d/K??viasound ]; then
                  	     ln -s -f  /etc/init.d/viasound /etc/rc.d/rc${runlevel}.d/K14viasound
		             ln -s -f /etc/init.d/viasound /etc/rc.d/rc${runlevel}.d/S14viasound
                	fi

       		done          
	else
		rm /etc/init.d/viasound
	fi

	if [ -f  /etc/rc.d/rc.local ]; then
		sed  's/modprobe snd-pcm-oss/#modprobe snd-pcm-oss/' /etc/rc.d/rc.local >rc.local.tmp
		if [ -f rc.local.tmp ]; then
	        	mv  rc.local.tmp /etc/rc.d/rc.local
                	chmod a+x /etc/rc.d/rc.local
			chmod a+x /etc/rc.d/rc.local
                	chmod a+x /etc/rc.d/rc.local
		fi
	fi
	
	#remove pre-installed sound modules
	if lsmod |grep -q "snd-via82xx" ;then
		modprobe -r snd-via82xx
		modprobe -r snd-pcm-oss
		modprobe -r snd-pcm
		modprobe -r snd-mixer-oss
		modprobe -r snd-seq-oss
	elif lsmod|grep -q "snd-via8233" ; then
		modprobe -r snd-via8233
		modprobe -r snd-pcm-oss
		modprobe -r snd-pcm
		modprobe -r snd-mixer-oss
		modprobe -r snd-seq-oss
	elif lsmod |grep -q "snd-card-via8233"; then
		modprobe -r snd-card-via8233
		modprobe -r snd-pcm-oss
		modprobe -r snd-pcm
		modprobe -r snd-mixer-oss
		modprobe -r snd-seq-oss
	elif lsmod |grep -q "snd-card-via686";then
		modprobe -r snd-card-via686a
		modprobe -r snd-pcm-oss
		modprobe -r snd-pcm
		modprobe -r snd-mixer-oss
		modprobe -r snd-seq-oss
	elif lsmod |grep -q "via82cxxx_audio"; then
		modprobe -r via82cxxx_audio
	fi

	#install new sound module
 	if [  "$OSProduct" = "Mandrake" ] ;then
		if [ -f /etc/modules ] ; then
			cp /etc/modules.conf /etc/modules
		fi
		gzip /lib/modules/`uname -r`/kernel/drivers/sound/viaudiocombo.o
		depmod -a
	else
		depmod -a
	fi	
	modprobe viaudiocombo 
	

echo -e " -------- vinstall end --------"


%preun
#!/bin/bash
KERNELVERSION=`uname -r`
SOUNDDRIVERDIR=/lib/modules/$KERNELVERSION/kernel/drivers/sound
MODULESDEPDIR=/lib/modules/$KERNELVERSION
MODULESCONFDIR=/etc
MODULESCONFFILE=$MODULESCONFDIR/modules.conf
OLDMODULESCONFFILE=$MODULESCONFDIR/old.modules.conf

echo -e " -------- vunstall start --------"
#VT686A, VT686B, VT8231, VT8233, VT8233A, VT8233C, VT8235 Shell script 

	#recovery the sound setting in /etc/init.d/rc${runlevel}.d
	if  grep -q "Mandrake" /etc/issue  ; then
        	OSProduct="Mandrake"
	elif  grep -q "SuSE" /etc/issue ; then
        	OSProduct="SuSE"
	elif  grep -q "Red Flag" /etc/issue ; then
        	OSProduct="Red Flag"
	fi
	if [ ! -x /etc/init.d/sound ]; then
        	LEVEL="  2 3  5  "
        	for runlevel in $LEVEL; do
           	        if [  -L /etc/rc.d/rc${runlevel}.d/K14viasound ]; then
                                rm -f /etc/rc.d/rc${runlevel}.d/K14viasound
                                rm  -f /etc/rc.d/rc${runlevel}.d/S14viasound
	   	        fi
	   		if [ ! -L /etc/rc.d/rc${runlevel}.d/K??alsasound -a -f /etc/init.d/alsasound ]; then
		                ln -s -f /etc/init.d/alsasound /etc/rc.d/rc${runlevel}.d/K14alsasound
          		 fi
        	done
	fi

	if [ -f /etc/rc.d/rc.local ] ;then
		sed 's/\#modprobe snd-pcm-oss/modprobe snd-pcm-oss/' /etc/rc.d/rc.local > rc.local.tmp
		if [ -f rc.local.tmp ] ; then
			mv rc.local.tmp /etc/rc.d/rc.local
			chmod a+x /etc/rc.d/rc.local
			chmod a+x /etc/rc.d/rc.local
		fi
	fi
        
	#remove viaudiocombo module
	modprobe -r viaudiocombo
	
 	#recovery moduels.conf
        if [ -f $OLDMODULESCONFFILE ] ; then
		cp $OLDMODULESCONFFILE $MODULESCONFFILE
		rm $OLDMODULESCONFFILE
		echo -e " recover modules.conf"
	else
		echo -e " old.modules.conf not exist"						
	fi
											 	
	if [ "$OSProduct" = "Mandrake" ] ; then
		if [ -f /etc/modules ] ; then
			cp  /etc/modules.conf /etc/modules
		fi
		gunzip -f  $SOUNDDRIVERDIR/viaudiocombo.o.gz
	fi
        

echo -e " -------- vunstall end --------"


%clean
rm -rf $RPM_BUILD_ROOT

%files

%defattr(-,root,root)
/lib/modules/%{kerver}/kernel/drivers/sound/viaudiocombo.o
/etc/init.d/viasound
%changelog
*Mon Feb 24 2003 ttpan <ttpan@viatech.com.cn>
 -build via  sound driver rpm package 
